<?php

/**
 * define regions
 **/
function whatsinitsname_regions() {
  return array(
    'content' => t('content'),
    'branding' => t('branding'),
    'navigation' => t('navigation'),
    'tools' => t('tools'),
    'search' => t('search'),
    'siteinfo' => t('siteinfo'),
    'content_prefix' => t('before content'),
    'content_postfix' => t('after content'),
  );
}

/**
 * Additional theme functions that should be in core, but are not
 */

/**
 * Terms are now themed trough a way too general theme_links.
 * This function is special fior terms in a node.
 */
function whatsinitsname_taxonomy_terms_for_node($node) {
  $links = taxonomy_link('taxonomy terms', $node);
  if (count($links)) {
    return _phptemplate_callback('taxonomy_terms_for_node', array('links' => $links, 'terms' => $node->taxonomy, 'node' => $node));
  }
  else {
    return '';
  }
}
/**
 * Messages are now themed in a complex blurb.
 */

/**
 * Additional tpl callbacks
 **/

/** menu and navigation functions **/
function whatsinitsname_primary_links($links) {
  return _phptemplate_callback('primary_links', array('links' => $links));
}
function whatsinitsname_secondary_links($links) {
  return _phptemplate_callback('secondary_links', array('links' => $links));
}

function whatsinitsname_menu_tree($pid = 1) {
  if ($tree = menu_tree($pid)) {
    // TODO a static var that counts the depth.
    return _phptemplate_callback('menu_tree', array('tree' => $tree, 'pid' => $pid));
  }
}

/** Local tasks AKA tabs**/
function whatsinitsname_menu_local_tasks() {
  $output = '';

  //TODO: build the $links not as an ugly string, but rather an array of items!
  if ($links = menu_primary_local_tasks()) {
    $output = _phptemplate_callback('menu_local_tasks_primary', array('links' => $links));
    $links = '';
  }
  if ($links = menu_secondary_local_tasks()) {
    $output .= _phptemplate_callback('menu_local_tasks_secondary', array('links' => $links));
  }

  return $output;
}

/** a single Localtask AKA tab **/
function whatsinitsname_menu_local_task($mid, $active, $primary) {
  return _phptemplate_callback('menu_local_task', array('mid' => $mid, 'active' => $active));
}
function whatsinitsname_menu_item_link($item, $link_item) {
  return _phptemplate_callback('menu_item_link', array('item' => $item, 'link_item' => $link_item));
}

function whatsinitsname_breadcrumb($breadcrumb) {
  if (!empty($breadcrumb)) {
    return _phptemplate_callback('breadcrumb', array('links' => $breadcrumb));
  }
}

/** General core functions **/

/** search functions **/
function whatsinitsname_search_theme_form($form) {
  return _phptemplate_callback('search_form', array('form' => $form));
}
function whatsinitsname_search_block_form($form) {
  return _phptemplate_callback('search_form', array('form' => $form));
}

/** messages and help **/
function whatsinitsname_status_messages() {
  if ($data = drupal_get_messages()) {
    foreach ($data as $type => $messages) {
      $grouped_messages .= _phptemplate_callback('status_messages_by_type', array(
        'messages' => $messages,
        'type' => $type,
      ));
    }
    return _phptemplate_callback('status_messages', array(
      'grouped_messages' => $grouped_messages,
    ));
  }
}

/** Special contrib functions **/

/** flexinode output **/
function whatsinitsname_flexinode_textfield($field_id, $label, $value, $formatted_value) {
  return _phptemplate_callback('flexinode_textfield', array(
    'field_id' => $field_id,
    'label' => $label,
    'value' => $value,
    'formatted_value' => $formatted_value,
  ));
}
function whatsinitsname_flexinode_image($field_id, $label, $image, $formatted_value) {
  return _phptemplate_callback('flexinode_image', array(
    'field_id' => $field_id,
    'label' => $label,
    'image' => $image,
    'formatted_value' => $formatted_value,
  ));
}

/** Make additional variables available and override some core variables **/
function _phptemplate_variables($hook, $vars) {
  switch ($hook) {
    case 'page':
    break;
    case 'node':
      $vars['terms'] = theme('taxonomy_terms_for_node', $vars['node']);
    break;
  }
  return $vars;
}

?>